/*
	HASCoolAboutBox.h from Hsoi's App Shell 1995-1997 John C. Daub.  All rights reserved.
	
	This is the corresponding header file to HASCoolAboutBox.c.  Note the praga align
	to "ensure" that the structs get aligned to 68k boundries.
*/

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif


enum {
	PIXEL_DEPTH		=	8,
	BOUNCE			=	15,
	FADE_LEVELS		=	12,
	FONT_SIZE		=	9
};

typedef struct UserItemRec	{
	long padding1;
	Rect box;
	short padding2;
} UserItemRec;

typedef struct DITLRec	{
	short numItems;
	UserItemRec theUserItems[1];
} DITLRec, **DITLHand;

typedef struct CreditsRec
{
	GWorldPtr		theGWorldPtr;
	Rect			viewRect;
	Rect			pictRect;
	short			pictHeight;
} CreditsRec;

typedef struct LogoRec
{
	GWorldPtr		theGWorldPtr;
	Rect			currPos;
	Rect			imagePos;
	short			bottomLoc;
} LogoRec;

typedef LogoRec VersionRec;

typedef enum AnimateState
{
	animate_Waiting,
	animate_Active,
	animate_Done
} AnimateState;

static CWindowPtr		aboutBoxWindow;
static PixMapPtr		windowPixMapPtr;
static GWorldPtr		gDrawWorldPtr;
static PixMapPtr		gDrawPixMapPtr;
static GWorldPtr		gBackWorldPtr;
static PixMapPtr		gBackPixMapPtr;

// local function prototypes


void			HsoiGetItemRect( short, Rect * );
void			HsoiDrawPictIntoNewGWorld(short, short, GWorldPtr * );
void			HsoiSetUpLogo( LogoRec * );
void			HsoiSetUpVersion( VersionRec * );
void			HsoiDrawTextIntoNewGWorld(short, Rect *, short, GWorldPtr * );
void			HsoiSetUpCredits(CreditsRec * );
void			HsoiMoveLogoBox(GWorldPtr, Rect *, short );
void			HsoiMoveOffWorld(GWorldPtr, Rect *, Rect *, Rect * );

void			HsoiDoCoolAboutBox( void );
void			HsoiSetUpCoolAboutBox( void );
void			HsoiDoCoolStuff( void );
void			HsoiCleanUpCoolAboutBox( void );


#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#ifdef __cplusplus
}
#endif


