/*
	HASUtilCursors.h from Hsoi's App Shell.   1995-1997 John C. Daub.  All rights reserved.
	
	This is the header file for HASUtilCursors.c containing the relevant function
	prototypes, constants, resource ID's, etc.
*/

#ifndef __QUICKDRAW__
#include <QuickDraw.h>
#endif
#ifndef __CURSORCTL__
#include <CursorCtl.h>
#endif
#ifndef __CONDITIONALMACROS__
#include <ConditionalMacros.h>
#endif

//========================
// Constants
//========================

// first, some constants

enum {
	kInterval			= 4,	// frequency in interrupts
	kNumberOfCursors	= 8,	// total number of frames
	kInitialResID		= 6500,	// ID of first CURS resource
	kInitialDelay		= 120	// initial delay before starting to spin
};


// create a nice array for our cursors, typedefed for nice inclusion in our CursorTask struct

typedef CursHandle	CursorsList[kNumberOfCursors];

// our CursorTask struct..holds necessary info for the VBL Task to execute

struct CursorTask {
	VBLTask		myVBLTask;	// the actual VBL Task
	CursorsList myCursors;	// handles to me cursors
	short		myFrame;	// cursor frame to display next
};
typedef struct CursorTask CursorTask, *CursorTaskPtr;





//========================
// Resource IDs
//========================


/*
 *	'acur' resource numbers
 */

enum {
	rSpinningWatchACUR		=	0
};



//========================
// #defines
//========================


#ifndef TYPE_ANIMATED_CURSOR
#define TYPE_ANIMATED_CURSOR	'acur'
#endif


//========================
// Function Prototypes
//========================

void			HsoiIBeamIt( WindowRef );
void			HsoiSetUpCursors( void );
OSErr			HsoiStartManualSpinning( void );
OSErr			HsoiStopManualSpinning( void );
void			HsoiAdjustCursor( Point, RgnHandle );
/*
#if GENERATINGPOWERPC

void	HsoiChangeCursor( CursorTaskPtr recPtr );

#else

void	HsoiChangeCursor( void );

#endif
*/
void			HsoiStartVBLSpinning( void );
void			HsoiStopVBLSpinning( void );
