// MADE - Macintosh Application Development Essentials
// ---------------------------------------------------

// (c) Gideon Greenspan, Sig Software - June 1997 - http://www.kagi.com/gdg/

// These files can only be used for experimental standalone purposes. To obtain
// fully commented code, and licenses for standalone, shareware, internal and
// commercial usage, run the enclosed Register application.

// Essential Prototypes.h
//
// These are prototypes for functions probably needed only by MADE source files.
//
// Version 1.0.0 - 10th November 1996
// Version 1.0.1 - 4th June 1997
//                 Fixed macro, function names

// *************************************************************************
// Functions you need to implement - these are currently in User Functions.c
// *************************************************************************

void	MyInitialiseApplication();
			// Open preference files, initialise data structures, etc...
void	MyClearUpApplication();
			// Close preference files, deconstruct structures (!) etc...
			
#if Use_AppleEvents

	#if Handle_Open_Documents_Event

		void	MyOpenDocument(FSSpec* fileSpec);
					// Respond to Open AppleEvent of specified file
	#endif

	#if Handle_Print_Documents_Event
	
		void	MyPrintDocument(FSSpec* fileSpec);
					// Respond to Print AppleEvent of specified file
	#endif

#endif

#if Use_Drag_Manager

	RgnHandle	MyGetDragRegion(WindowPtr inWindow, Point localPoint, DragReference dragRef);
					// Here you must give a region for hiliting during drag tracking for
					// specified drag in inWindow at localPoint. You must return a region that
					// can be destroyed. You can return 0 to signify no region for hiliting.

	void		MyReceiveDrag(WindowPtr inWindow, Point localPoint, DragReference dragRef);
					// Receive the specified drag in inWindow at localPoint
					
#endif

void	MyPerformIdleTasks();
			// Perform any tasks when no events are forthcoming
void	MyFreeUpMemory(Size spaceNeeded);
			// Try to free memory up so spaceNeeded contiguous bytes are available. MaxBlock()
			// will tell you how you are doing. If you can't manage it, don't worry - MADE
			// handles that possibility by producing a memory full error.

void	MyEnableMenus();
			// Enable or disable all menu items as necessary; you can use EnableMenuItem. This
			// is called just before the menus are dropped down or a key equivalent used.
void	MyPerformMenu(long selection);
			// Execute the given menu item. The top 16 bits give the menu ID, and the bottom
			// 16 bits given the item number. You can use HiWord() and LoWord() to extract
			// these, or work directly on selection. External Apple Menu Items are dealt with.

void	MyDrawWindow(WindowPtr drawWindow);
			// Drag the specified window. Use the visRgn to determine where it needs drawing.
			// The current GrafPort will be set correctly to drawWindow.
			
// NOTE: The following 8 functions all operate within the context of the global variable
// frontWindow, without exception. All of them will have the current GrafPort set to
// frontWindow so you can perform any necessary drawing or other operations.

void	MySetTheCursor(Point localPoint);
			// Show correct cursor for position localPoint in frontWindow; may use ShowResCursor
void	MyHandleKeyDown(char keyCharacter, short modifiers);
			// Deal with a key down (or auto key) event of keyCharacter with modifiers
void	MyHandleMouseDown(Point localPoint, short modifiers);
			// Deal with a mouse down event at localPoint with modifiers
void	MyCloseWindow();
			// Close frontWindow
void	MyActivateWindow();
			// Activate frontWindow; consider showing controls
void	MyDeactivateWindow();
			// Deactivate frontWindow; consider hiding controls
void	MyResizeBounds(Rect* growLimits);
			// Return window resizing limits for frontWindow for GrowWindow system call
void	MySizedWindow();
			// Deal with the frontWindow having been resized after SizeWindow or ZoomWindow

// ***********************************************
// Functions that are used within the MADE package
// ***********************************************

// From Essential Shell.c

void	ExecutionBody();

// From Essential Menus.c

Error	InitMenuBar();
void	SelectMenuItem(long selection);
void	EnableMenuItem(short menuID, short menuItem, Boolean enable);
#if Use_Drag_Manager
	Error	InitDragManager();
#endif

// From Essential Events.c

void	MainEventLoop();
#if Use_AppleEvents
	Error	CheckRequiredParams(AppleEvent* theEvent);
	Error	InitAppleEvents();
#endif

// From Essential Memory.c

Error	CreateHeapSpace(Size required);
#if Project_Under_Development && Initialise_Allocated_Memory
	void	InitialiseMemory(char* pointer, Size length);
#endif

